; Only for 32-Bit.
[Bits #32]
GetDeltaXY proc				; x,y,x2,y2
	
	pop [ebp+#16]
	
	pop [ebp+#12]		; y2
	pop [ebp+#8]		; x2
	pop [ebp+#4]		; y
	pop [ebp]			; x
	
	push [ebp+#16]		;
	
	mov edx,[ebp+#8]	; x2-x
	sub edx,[ebp]		; dx
	
	mov eax,[ebp+#12]	; y2-y
	sub eax,[ebp+#4]	; dy
	
	; dx:dy := edx:eax
	
	ret
GetDeltaXY endp				; ret value is [dx:=edx,dy:=eax]

GetHypotenusa proc			; dx,dy
	
	pop [ebp+#8]
	
	pop [ebp+#4]	; dy
	pop [ebp]		; dx
	
	push [ebp+#8]
	
	mov eax,[ebp]
	mul eax
	mov ecx,eax
	
	mov eax,[ebp+#4]
	mul eax
	add ecx,eax
	push ecx
	
	finit
	fild fd.[esp]
	fsqrt
	fistp fd.[esp]
	
	pop eax			; Hypotenusa at eax
	
	ret
GetHypotenusa endp			; ret value is [hyp:=eax]

FastGetDegree proc			; dX,dY
	; Get Degree from Position
	
	pop [ebp+#16]		; EIP
	
	pop [ebp+#4]		; dy
	pop [ebp]			; dx
	
	push [ebp+#16]		; EIP
	
	
	; Atan2(dy,dx)
	; degrees=(angle/PI)*180
	; angle  =(degrees/180)*PI 
	push [ebp]
	push [ebp+#4]
	call aTan2
	
	call Rad2DegP
	mov edx,eax
	
	
	xor eax,eax
	inc eax
	
	ret
FastGetDegree endp			; eax=Status, edx=Rotasi/10

aTan2 proc					; dy,dx
	
	pop [ebp+#8]
	
	pop [ebp+#4]			; Y
	pop [ebp]				; X
	
	push [ebp+#8]
	
	fild fd.[ebp+#4]		; Y
	fild fd.[ebp]			; X
	fpatan
	; Did you see, 3 line above. 1 Month for me to understand how to 
	; use it. :(
		
	ret
aTan2 endp					; Result are at st(0)

aCos proc					; src Must be at FPU
	
	fclex				; Clear exception
	fld st(0)			; copy src
	fmul st,st(0)		; cos^2
	fld1				; load 1 at st(0)
	fsub st,st(1)		; 1-Cos^2=sin^2
	fsqrt
	fxch				; exchange it
	fpatan				; atan(sin/cos)
	
	fstsw [ebp]			; store status
	fwait
	mov ax,[ebp]
	test al,1			; Is it error?
	jz aCos_no_error	;
		finit
		xor eax,eax		; Failed
		dec eax
		ret				; Failed
aCos_no_error data
	
	ret
aCos endp					; Result are at st(0)

aSin proc					; src Must be at FPU
		
	fclex				; Clear any Exception
	fld st(0)			; st(0)=st(1)
	fmul st,st(0)		; st(0)=st(0)*st(0)
	fld1				; st(0)=1,st(2)=sin^2,st(3)=sin
	fsub st,st(1)		; st(0)=1-sin^2
	fsqrt 				; sqrt(st(0))
	fpatan				; atan(st(0))
	
	fstsw [ebp]			; store status
	fwait
	mov ax,[ebp]
	test al,1			; Is it error?
	jz aSin_no_error	;
		finit
		xor eax,eax		; Failed
		ret				; Failed
aSin_no_error data
	
	ret
aSin endp					; result are at st(0)

HitX proc					; Calculate a = rot * (3.14/180)
;// a:=rot*PI/180
;// r:=sqrt(lbr*lbr).
;// hitx:=round(x+sin(a)*r) Used to count X, for Y change it to Cos.
;// The parameter are, [ebp]= PosX, [ebp+4]=Width/lbr(lebar),
;// [ebp+8]=Rotation/angle

	pop [ebp+#12]
	
	pop [ebp+8]		; Rot
	pop [ebp+#4]	; Width
	pop [ebp]		; PosX

	push [ebp+#12]

	finit				; Init Prosesor
	fldpi				; Load Phi
	push d.#180			; Push 180 degree
	fidiv fd.[esp]		; Div it with #180
	pop eax				; eax are Junk
	
	fild [ebp+#8]		; Rot
	push d.#10			;
	fidiv fd.[esp]		; Rot/#10, We got float here
	pop eax				; eax are Junk
	
	fmul st,st(1)		; Mul, a = (rot/#10) * (Phi/180)
	fcos				; cos=st(0), sin=st(1)
	;fwait
	
	fimul fd.[ebp+#4]	; Cos*w/h
	fistp fd.[ebp+#12]	; Cosine
	mov eax,[ebp+#12]
	
	mov edx,eax
	
	add eax,[ebp]	        ; Done.)
	sub [ebp],edx
	mov edx,[ebp]

	ret
HitX endp

HitY proc					; X,width,Rotation
;// a:=rot*PI/180
;// r:=sqrt(lbr*lbr).
;// hitx:=round(x+sin(a)*r) Used to count X, for Y change it to Cos.
;// The parameter are, [ebp]= PosX, [ebp+4]=Width/lbr(lebar),
;// [ebp+8]=Rotation/angle

	pop [ebp+#12]
	
	pop [ebp+8]		; Rot
	pop [ebp+#4]	; Width
	pop [ebp]		; PosX
	
	push [ebp+#12]
	
	finit				; Init Prosesor
	fldpi				; Load Phi
	push d.#180			; Push 180 degree
	fidiv fd.[esp]		; Div it with #180
	pop eax				; eax are Junk
	
	fild [ebp+#8]		; Rot
	push d.#10			;
	fidiv fd.[esp]		; Rot/#100, We got float here
	pop eax				; eax are Junk
	
	fmul st,st(1)		; Mul, a = (rot/#100) * (Phi/180)
	fsin				; cos=st(0), sin=st(1)
	;fwait
	
	fimul fd.[ebp+#4]	; Cos*w/h
	fistp fd.[ebp+#12]	; Cosine
	mov eax,[ebp+#12]
	mov edx,eax
	
	add eax,[ebp]	        ; Done.)
	sub [ebp],edx
	mov edx,[ebp]

	ret
HitY endp

Deg2Rad proc				; Degree
	; deg*PI/180
	
	pop [ebp+#4]
	pop [ebp]
	push [ebp+#4]
	
	fldpi				; Load Phi
	push d.#180			; Push 180 degree
	fidiv fd.[esp]		; Div it with #180
	pop eax				; eax are Junk
	
	fild [ebp]			; Rot
	push d.#10			;
	fidiv fd.[esp]		; Rot/#100, We got float here
	pop eax				; eax are Junk
	
	fmul st,st(1)		; Mul, a = (rot/#100) * (Phi/180)
	
	
	ret
Deg2Rad endp				; Radian at FPU st(0)

Rad2DegP proc				; Radian at FPU st(0)
	; Rad * 180/PI
	; Radian to degree Partial
	; 57,295779513087679
	; st(0) are FPatan(dx/dy)
	;push d.#573
	;	fimul fd.[esp]
	;	fistp fd.[esp]
	;pop eax
	push d.#1800
		fldpi
		fidivr fd.[esp]
		fmul st,st(1)
		fistp fd.[esp]
	pop eax
	;test eax,80000000		; Check for Minus Sign
	;jz r2d_brs
	;	add eax,#3600		;
		
r2d_brs data	
	ret
Rad2DegP endp				; Result at eax

GetDeltaXYnHyp proc			; xc,yc,x,y
	
	pop [ebp+#20]			; Eip
		pop [ebp+#12]		; y
		pop [ebp+#8]		; x
		pop [ebp+#4]		; yc
		pop [ebp]			; xc
	push [ebp+#20]			; Eip
	push ebp
		push [ebp]
		push [ebp+#4]
		push [ebp+#8]
		push [ebp+#12]
		add ebp,#128
		call GetDeltaXY
	pop ebp
	push edx
	push eax
	push ebp
		push edx
		push eax
		add ebp,#128
		call GetHypotenusa
		mov ecx,eax
	pop ebp
	pop eax
	pop edx
	
	
	ret
GetDeltaXYnHyp endp			; edx:=dx,eax:=dy,ecx:=Hyp

Rotate2D proc				; xc,yc,x,y,Rot
	
	pop [ebp+#20]			; EIP
		pop [ebp+#16]		; Rot
		pop [ebp+#12]		; y
		pop [ebp+#8]		; x
		pop [ebp+#4]		; yc
		pop [ebp]			; xc
	push [ebp+#20]			; EIP
	push ebp
		push [ebp]			; x
		push [ebp+#4]		; y
		push [ebp+#8]		; x2
		push [ebp+#12]		; y2
		add ebp,#128
		call GetDeltaXYnHyp
	pop ebp
	mov [ebp+#20],edx		; dx
	mov [ebp+#24],eax		; dy
	mov [ebp+#28],ecx		; Hypotenusa
	push ebp
		push [ebp+#20]		; x2
		push [ebp+#24]		; y2
		add ebp,#128		;
		call FastGetDegree	;
	pop ebp
	add edx,[ebp+#16]
	mov [ebp+#32],edx
	
	push ebp
		push [ebp]			; x
		push [ebp+#28]		; hyp
		push [ebp+#32]		; Rot
		add ebp,#128
		call HitX			;
	pop ebp
	mov [ebp+#36],eax
	push ebp
		push [ebp+#4]
		push [ebp+#28]
		push [ebp+#32]
		add ebp,#128		;
		call HitY
	pop ebp
	
	mov edx,[ebp+#36]
	
	ret
Rotate2D endp				; edx:=x,eax:=y

HitXorY proc
 
 
 
 RET
HitXorY endp

GetA proc  
 ; The formula is a:= (22/7)/180
 
 fld1
 
 ret
GetA endp